
ActiveEmotes = { }

UpdateFrame = nil

EnableAnimations = true

function TheAddon_OnUpdate(self, elapsed)
	local regions = { ChatFrame1:GetRegions() }
	-- TODO add other chat frames
	
	for i,region in ipairs(regions) do
		if region:GetObjectType() == "FontString" and region:IsVisible() then
			for texturePath,size1,size2,xoffset,yoffset,dimx,dimy,coordx1,coordx2,coordy1,coordy2 in string.gmatch(region:GetText(), "\124TInterface\\AddOns\\TheAddon\\Textures\\([%w%-]+).tga:(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+)\124t") do
				if(Emotedata[texturePath] and Emotedata[texturePath].FrameCount > 1) then 
					if(ActiveEmotes[texturePath]) then
						local timeSinceStarted = GetTime() - ActiveEmotes[texturePath].Started
						--ActiveEmotes[texturePath].Frame = ActiveEmotes[texturePath].Frame + 1
						-- TODO pull out if anim frame doesnt change this render frame
						ActiveEmotes[texturePath].Frame = math.floor((timeSinceStarted / Emotedata[texturePath].Duration) * Emotedata[texturePath].FrameCount)
						if(ActiveEmotes[texturePath].Frame >= Emotedata[texturePath].FrameCount or ActiveEmotes[texturePath].Frame < 0) then
							ActiveEmotes[texturePath].Frame = 0
							ActiveEmotes[texturePath].Started = GetTime()
						end
					else
						ActiveEmotes[texturePath] = { Frame = 0, Started = GetTime() }
					end
					local newcoordx1 = Emotedata[texturePath].TexCoords[ActiveEmotes[texturePath].Frame+1][1]
					local newcoordx2 = Emotedata[texturePath].TexCoords[ActiveEmotes[texturePath].Frame+1][2]
					local newcoordy1 = Emotedata[texturePath].TexCoords[ActiveEmotes[texturePath].Frame+1][3]
					local newcoordy2 = Emotedata[texturePath].TexCoords[ActiveEmotes[texturePath].Frame+1][4]
					region:SetText(string.gsub(region:GetText(), "\124TInterface\\AddOns\\TheAddon\\Textures\\([%w%-]+).tga:(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+)\124t",  "\124TInterface\\AddOns\\TheAddon\\Textures\\%1.tga:%2:%3:%4:%5:%6:%7:"..newcoordx1..":"..newcoordx2..":"..newcoordy1..":"..newcoordy2.."\124t"))
				end
			end
		end
	end
end

local function theAddonFilter(self, event, mesg, author, ...)
  if strfind(mesg, "\124H") then return false end
  mesg = messageReplaceFilter(":[%w%-]+:", mesg, self)
  
  return false, mesg, author, ...
end

function messageReplaceFilter(match, mesg, self)
  for emote in string.gmatch(mesg, match) do
    emote = emote.gsub(emote, ":", "")
    if (Emotedata[emote]) then
      mesg = mesg.gsub(mesg, ":" .. emote .. ":", showEmote(emote, self))
    end
  end
  return mesg
end

function showEmote(emoticon, self)
    if(UpdateFrame == nil and EnableAnimations == true) then
		UpdateFrame = CreateFrame("Frame", "TheAddonUpdateFrame", UIParent)
		UpdateFrame:SetScript("OnUpdate", TheAddon_OnUpdate)
	end
	
	local emoteMeta = Emotedata[emoticon]
	
    return "\124TInterface\\AddOns\\TheAddon\\Textures\\" .. emoteMeta.Texture .. ":" .. emoteMeta.Height .. ":" .. emoteMeta.Width .. ":0:0:"..emoteMeta.TextureWidth..":"..emoteMeta.TextureHeight..":0:"..emoteMeta.Width..":0:".. emoteMeta.Height .."\124t"
end

ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL",             theAddonFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY",                 theAddonFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL",                theAddonFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER",             theAddonFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_GUILD",               theAddonFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_OFFICER",             theAddonFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY",               theAddonFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID",                theAddonFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BATTLEGROUND",        theAddonFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_LEADER",         theAddonFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BATTLEGROUND_LEADER", theAddonFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY_LEADER",        theAddonFilter)